//-----------------------------------------------------
//	`֘ACu
//	Xt@Cǂݍ݁A`
//	2010.02.05 TMO
//-----------------------------------------------------
#include "stdafx.h"
#include "Graphic.h"

//쐬ꂽD3DfoCX擾
extern LPDIRECT3DDEVICE9 GetDevice();

XFileObject::XFileObject()
{
	m_pMesh = NULL;
	m_dwNumMaterials = 0;
	m_ppTextures = NULL;
	m_pMatrs = NULL;
}

//Xt@Cǂݍ
bool XFileObject::Load( LPCWSTR file )
{
	//Xt@C̃fBNg擾(eNX`̃[hɎg)
	wchar_t dir[_MAX_DIR];
	_wsplitpath_s(file, NULL,0,dir,_MAX_DIR,NULL,0,NULL,0);

	//Xt@C[h
	LPD3DXBUFFER pD3DBufMtr;
	if ( D3D_OK != D3DXLoadMeshFromX(file, D3DXMESH_SYSTEMMEM, GetDevice(), NULL, &pD3DBufMtr, NULL, &m_dwNumMaterials, &m_pMesh ) ) {
		return false;
	}
	
	//Xt@Cɖ@Ȃꍇ́A@
	if ( !(m_pMesh->GetFVF() & D3DFVF_NORMAL) ) {
		
		ID3DXMesh* pTempMesh = NULL;
		
		m_pMesh->CloneMeshFVF(m_pMesh->GetOptions(),
				m_pMesh->GetFVF()|D3DFVF_NORMAL, GetDevice(), &pTempMesh );
	
		D3DXComputeNormals(pTempMesh, NULL);
		m_pMesh->Release();
		m_pMesh = pTempMesh;
	}
	
	//}eAAeNX`̏
	m_pMatrs = (D3DMATERIAL9*)malloc(sizeof(D3DMATERIAL9) * m_dwNumMaterials);
	m_ppTextures = (LPDIRECT3DTEXTURE9*)malloc(sizeof(LPDIRECT3DTEXTURE9) * m_dwNumMaterials);

	D3DXMATERIAL* d3dxmatrs = (D3DXMATERIAL*)pD3DBufMtr->GetBufferPointer();

	for (int i = 0; i < (int)m_dwNumMaterials; i++) {
		
		//}eA
		m_pMatrs[i] = d3dxmatrs[i].MatD3D;
		m_pMatrs[i].Ambient = m_pMatrs[i].Diffuse;

		//eNX`[h
		m_ppTextures[i] = NULL;
		if ( d3dxmatrs[i].pTextureFilename != NULL ) {

			//eNX`wcharɕϊ
			wchar_t filename[1024];
			size_t num;
			ZeroMemory( filename, sizeof(filename) );
			mbstowcs_s( &num, filename, 1024, d3dxmatrs[i].pTextureFilename, _TRUNCATE );

			//eNX`t@CpX쐬
			wchar_t texturefile[1024];
			ZeroMemory( texturefile, sizeof(texturefile) );
			swprintf( texturefile, 1024, TEXT("%s%s"), dir, filename );

			if ( S_OK != D3DXCreateTextureFromFile( GetDevice(), texturefile, &m_ppTextures[i] ) ) {
				m_ppTextures[i] = NULL;
			}
		}
	}

	pD3DBufMtr->Release();

	return true;

}

//`
void XFileObject::Render()
{
	GetDevice()->SetVertexShader(NULL);
	GetDevice()->SetFVF( m_pMesh->GetFVF() );

	for (unsigned int u = 0; u < m_dwNumMaterials; u++)
	{
		GetDevice()->SetMaterial(&m_pMatrs[u]);
		GetDevice()->SetTexture(0, m_ppTextures[u]);
		m_pMesh->DrawSubset(u);
	}

}

void XFileObject::Render(D3DMATRIX& mat)
{
	GetDevice()->SetTransform( D3DTS_WORLD, &mat );
	
	Render();

	
	D3DXMATRIX normal;
	D3DXMatrixIdentity(&normal);
	GetDevice()->SetTransform( D3DTS_WORLD, &normal );

}

//\[X
void XFileObject::Release()
{
	//}eA
	free(m_pMatrs);
	m_pMatrs = NULL;

	//eNX`
	for (unsigned int u = 0; u < m_dwNumMaterials; u++)
	{
		if ( m_ppTextures[u] ) {
			m_ppTextures[u]->Release();
		}
	}
	free(m_ppTextures);
	m_ppTextures = NULL;
}