#include "stdafx.h"
#include "Graphic.h"
#include "resource.h"

//XYZẻ]
struct Rotation
{
	float yaw;		//Y
	float pitch;	//X
	float roll;		//Z

	Rotation()
	{
		yaw   = 0;
		pitch = 0;
		roll  = 0;
	}
	
	//]s쐬
	D3DXMATRIX QueryMatrix()
	{
		D3DXMATRIX mat;
		D3DXMatrixRotationYawPitchRoll( &mat, yaw, pitch, roll );

		return mat;
	}

	//XYZẻ]Zbg
	void SetYawPitchRoll( float _yaw, float _pitch, float _roll )
	{
		yaw   = _yaw;
		pitch = _pitch;
		roll  = _roll;
	}

	//݂̉]炳ɉ]
	void RotationYawPitchRoll( float _yaw, float _pitch, float _roll )
	{
		yaw   += _yaw;
		pitch += _pitch;
		roll  += _roll;
	}

	//O֐i߂xNg쐬
	D3DXVECTOR3 QueryFrontVct( float prm )
	{
		D3DXVECTOR3	v(0,0,prm);
		D3DXVECTOR3	vout;
		
		D3DXVec3TransformCoord( &vout, &v, &QueryMatrix() );
		
		return vout;
	}

};

//ʒuƉ]\
struct PosRotation
{

	D3DXVECTOR3	m_pos;	//ʒu
	Rotation	m_rot;	//]

	PosRotation()
	{
		m_pos = D3DXVECTOR3(0, 0, 0);
	}
	
	//Wϊs쐬
	D3DXMATRIX Querytramsform()
	{
		//]sƈړsƁA̍Wϊł̍sɂȂB

		D3DXMATRIX mat_move;
		D3DXMatrixTranslation(&mat_move, m_pos.x, m_pos.y, m_pos.z);
		
		//W]Ăړ̂ŁAsꍇ]
		D3DXMatrixMultiply( &mat_move, &m_rot.QueryMatrix(), &mat_move );

		return mat_move;
	}
	
	//ts߂
	D3DXMATRIX QueryInvtramsform()
	{
		D3DXMATRIX mat_inv;
		if ( NULL == D3DXMatrixInverse(&mat_inv, NULL, &Querytramsform() ) ) {
			_ASSERT(0);
		}
		return ( mat_inv );
	}

};

//J
enum KameraPattern
{
	FPS,	//vC[_
	TOP,	//^㎋_
	OBLIQUE,//vC[̎΂ߏォwǂJ
};

//vC[ƁAvC[ɘAJ
class Player : public PosRotation
{
	PosRotation	m_cam;		//Jp̈ʒu]

	KameraPattern m_ptn;	//J
	
	float		m_aglView;	//p

public:

	#define PLAYER_EYEHGT	10.0f	//vC[̖ڂ̍
	#define CAMERA_OFFSET	100.0f	//vC[ƃJ̊Ԃ̋

	Player()
	{
		m_pos = D3DXVECTOR3(0, 0, 0);

		SetCameraPattern( FPS );

	}
	
	//JʕύXƃp[^
	void SetCameraPattern( KameraPattern patn )
	{
		m_ptn = patn;
		switch ( patn )
		{
		case FPS:
			//vC[ڐ̃J
			m_cam.m_pos   = m_pos;
			m_cam.m_pos.y = PLAYER_EYEHGT;
			m_cam.m_rot   = m_rot;
			break;
		case TOP:
			//vC[̐^ɃJčsÂƐ^B
			m_cam.m_pos = m_pos;
			m_cam.m_pos.y += CAMERA_OFFSET;
			m_cam.m_rot.SetYawPitchRoll( 0.0f, D3DX_PI * 0.5, 0.0f);
			break;
		case OBLIQUE:
			//J΂߉ɌĂɉĂ
			m_cam.m_rot.SetYawPitchRoll( 0.0f, D3DX_PI * 0.25, 0.0f);
			m_cam.m_pos = m_cam.m_rot.QueryFrontVct( -CAMERA_OFFSET );
			break;
		}
	}
	
	//Jʎ擾
	KameraPattern GetCameraPattern( ) { return m_ptn; }

	//]AOiɂvC[ƃJ̈ړAăr[ϊs̍XV
	void Move( float front, float yaw, float pitch )	
	{
		if ( front != 0 ) {
			m_pos += this->m_rot.QueryFrontVct(front);
			
			m_pos.y = 0;//vC[nʂ痣Ȃ悤ɂĂB
		}
		
		//vC[y]̂(nʔē̂)
		m_rot.RotationYawPitchRoll( yaw, 0.0f,0.0f );

		//J̈ʒuZbg
		//ʒu\̓vC[̑΂ŗ^
		switch ( m_ptn )
		{
		case FPS:
			m_cam.m_pos = m_pos;
			m_cam.m_pos.y = PLAYER_EYEHGT;

			m_cam.m_rot.RotationYawPitchRoll( yaw, pitch,0.0f );//J́A[Asb`Ƃɉ]
			
			//r[ϊsZbgiJ̋tsj
			GetDevice()->SetTransform( D3DTS_VIEW, &(m_cam.QueryInvtramsform() ) );

			break;
		case TOP:
			m_cam.m_pos = m_pos;
			m_cam.m_pos.y += CAMERA_OFFSET;
			m_cam.m_rot.SetYawPitchRoll( 0.0f, D3DX_PI * 0.5, 0.0f);

			//r[ϊsZbgiJ̋tsj
			GetDevice()->SetTransform( D3DTS_VIEW, &(m_cam.QueryInvtramsform() ) );
			break;
		case OBLIQUE:
			//J̈ʒu]̓vC[̑΂ł

			//J̃sb`]i_̍ςj
			//[]͂Ȃ
			m_cam.m_rot.RotationYawPitchRoll( 0.0, -pitch , 0.0f );

			//]px0`90xȓɗ}
			if ( m_cam.m_rot.pitch < 0 ) { m_cam.m_rot.pitch = 0;}
			if ( m_cam.m_rot.pitch > ( D3DX_PI * 0.5f ) ) { m_cam.m_rot.pitch = ( D3DX_PI * 0.5f ); }

			//]ɃJ̑ΈʒuČvZB
			m_cam.m_pos = m_cam.m_rot.QueryFrontVct( -CAMERA_OFFSET );

			//vC[̈ʒu]tsɂāAɃJ̑Έʒu]̋ts
			//ɃvC[̌ǂJłB
			D3DXMATRIX	mat = QueryInvtramsform();
			mat *= m_cam.QueryInvtramsform();
			
			GetDevice()->SetTransform( D3DTS_VIEW, &mat );
			break;
		}
	}
	
	//vWFNV(ˉe)̐ݒ
	void UpdateProjection()
	{
		double aspect = 640 / 480;

		D3DXMATRIX matBaseProj;	
		D3DXMatrixPerspectiveFovLH(
				&matBaseProj,
				m_aglView,			//p
				(float)aspect,		//AXyNg
				1.0f,               //NbsOi߂قj
				1000000.0f);        //NbsOiق)
				GetDevice()->SetTransform( D3DTS_PROJECTION, &matBaseProj );
	
	}
	//pZbg
	void SetProjection(float agl)
	{
		m_aglView = agl;
		UpdateProjection();
	}
	
	//p
	void Zoom( float agl )
	{
		float min = D3DXToRadian(5.0f);
		float max = D3DX_PI * 0.5f;

		m_aglView += agl;

		if ( m_aglView < min ) {
			m_aglView = min;
		}
		if ( m_aglView > max ) {
			m_aglView = max;
		}

		UpdateProjection();
	}

};

class MyApp
{
	XFileObject			m_map;
	XFileObject			m_yajirusi;
	XFileObject			m_robo;

	Player				m_player;	//vC[
	PosRotation			m_obj;		//ĂƂɉ]IuWFNg̈ʒu

	LPD3DXFONT			m_font;
public:
	Player*		Player() { return &m_player; }

	//TvAv̏
	void Init(HWND hWnd)
	{
		//DirectX
		LGraphic_Create( hWnd );

		m_map.Load( _T(".\\data\\map.x") );
		m_yajirusi.Load( _T(".\\data\\yajirusi.x") );
		m_robo.Load( _T(".\\data\\robo.x") );
		
		m_obj.m_pos = D3DXVECTOR3(0,0,30);

		//3D\̐ݒ
		GetDevice()->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);
		GetDevice()->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
		GetDevice()->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
		
		//vWFNV(ˉe)̐ݒ
		m_player.SetProjection( (float)(D3DX_PI/4.0) );

		//Cg̐ݒ
		{
			
			GetDevice()->SetRenderState(D3DRS_LIGHTING,TRUE);
			D3DLIGHT9	light;
			::ZeroMemory(&light, sizeof(D3DLIGHT9));
			light.Type = D3DLIGHT_DIRECTIONAL;
			light.Diffuse.r  = 0.9f;   light.Diffuse.g = 0.9f;   light.Diffuse.b = 0.9f;
			light.Specular.r = 0.2f;  light.Specular.g = 0.2f;  light.Specular.b = 0.2f;
			light.Ambient.r  = 0.5f;   light.Ambient.g = 0.5f;   light.Ambient.b = 0.5f;
			light.Direction = D3DXVECTOR3(0.0f, -0.5f, -0.2f);
			GetDevice()->SetLight(0, &light);
			GetDevice()->LightEnable(0, TRUE);
		}
		
		//eLXg`NX쐬
		m_font = NULL;
		D3DXCreateFont(GetDevice(),10,0,FW_NORMAL , 1, FALSE ,DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, _T("lr "), &m_font );

	}

	void Roop()
	{
		float yaw = 0, pitch = 0;
		float front = 0;
		
		//L[
		if ( ::GetAsyncKeyState( VK_UP ) & 0x8000 ) { pitch = -0.1f; }
		if ( ::GetAsyncKeyState( VK_DOWN ) & 0x8000 ) { pitch = 0.1f; }
		if ( ::GetAsyncKeyState( VK_LEFT ) & 0x8000 ) { yaw = -0.1f; }
		if ( ::GetAsyncKeyState( VK_RIGHT ) & 0x8000 ) { yaw = 0.1f; }
		
		//Oi
		if ( ::GetAsyncKeyState( 'W' ) & 0x8000 ) { front = 1.0; }
		if ( ::GetAsyncKeyState( 'S' ) & 0x8000 ) { front = -1.0; }
		
		//Y[CAAEg
		if ( ::GetAsyncKeyState( 'E' ) & 0x8000 ) { m_player.Zoom(-0.1f);}
		if ( ::GetAsyncKeyState( 'D' ) & 0x8000 ) { m_player.Zoom(0.1f); }

		//vC[ړAJXV
		m_player.Move( front, yaw, pitch );
		
		//IuWFNg]
		m_obj.m_rot.RotationYawPitchRoll( 0.05f, 0.0f, 0.0f );

		//`
		Draw();
	}
	
	void Draw()
	{
		LGraphic_ClearAndBegin();
	
		//Xt@Ĉł̃XP[ĂĂ
		D3DXMATRIX scale;
		D3DXMatrixScaling(&scale, 10,10,10);
		
		//nʂ̕`
		m_map.Render(scale);
		
		D3DXMATRIX rot;//Xt@C-ZʂȂ̂180x]␳
		D3DXMatrixRotationY(&rot, D3DX_PI);

		//v[[
		if ( m_player.GetCameraPattern() != FPS ) {
			m_yajirusi.Render( ( scale * rot ) * m_player.Querytramsform() );
		}
		
		//邮܂邾̃IuWFNg
		m_robo.Render( ( scale * rot ) * m_obj.Querytramsform() );


		//
		RECT rect;
		rect.left = 10;
		rect.top  = 300;
		rect.right = 300;
		rect.bottom = 430;
		m_font->DrawTextW(NULL,_T("L[:]\nWL[:Oi\nSL[:\nEL[:Y[C\nDL[:Y[AEg"),-1, &rect, DT_NOCLIP, D3DCOLOR_ARGB(255, 0, 0, 0) );

		LGraphic_EndAndPresent();

	}

	//TvAv̉
	void Release()
	{
		if(m_font) {
			m_font->Release();
		}

		m_map.Release();
		m_yajirusi.Release();
		m_robo.Release();

		//DirectX̉
		LGraphic_Release();
	}

};
static MyApp myApp;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message)
	{
		case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_FPSCAM:
			myApp.Player()->SetCameraPattern(KameraPattern::FPS);
			break;
		case IDM_TOPCAM:
			myApp.Player()->SetCameraPattern(KameraPattern::TOP);
			break;
		case IDM_OBLCAM:
			myApp.Player()->SetCameraPattern(KameraPattern::OBLIQUE);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		//WM_PAINTł͕`悵܂B
		//ValidateRectgƎWM_PAINTĂ΂ȂȂBitXN[\̎j
		ValidateRect( hWnd, NULL );
		break;
	case WM_DESTROY:
		myApp.Release();//TvAv
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;
	
	//EBhENX̓o^
	WNDCLASSEX wcex;
	memset( &wcex, 0, sizeof(wcex) );
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_CAMERAWORK);
	wcex.lpszClassName	= TEXT("wcSample");

	if( !RegisterClassEx(&wcex) ) {
		return FALSE;
	}

	HWND hWnd;
	hWnd = CreateWindow(TEXT("wcSample"), TEXT("J[NTv"), WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
	CW_USEDEFAULT, 0, 640, 480, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}
	
	//TvAv̏
	myApp.Init(hWnd);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	for (;;) {
		if ( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			
			if ( GetMessage( &msg, NULL, 0, 0 ) > 0) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			} else {
				break;
			}

		} else {
			//Q[̏ł
			myApp.Roop();
		}
	}

	return (int) msg.wParam;
}